<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:gri="http://java.sun.com/jsf/composite/gri">
    <!-- params
          - managedBean: the java bean which implements HPDInitiator interface -->
    <!-- inserts:
          - additionalButtonsOnReport: buttons to be inserted in the report panel below the dataTable, on the right hand of the "perform another test" button
          - additionalPanels: extra panels to be added at the bottom of the page
          - requestConfig: the part of the page which allows the user to configure each part of the batchRequest -->
    <h:form id="globalForm">
        <s:div id="globalDiv">
            <h1>#{managedBean.simulatedActor.name}</h1>
            <gri:panel pid="createRequestPanel">
                <f:facet name="header">#{messages['net.ihe.gazelle.hpd.CreateBatchRequest']}</f:facet>
                <s:div styleClass="row" id="sequenceDiagram">
                    <div class="col-lg-4">
                        <gri:panel pid="simConfPanel">
                            <f:facet name="header">#{messages['net.ihe.gazelle.hpd.Simulator']}</f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Name']}</ui:define>
                                    <h:outputText value="#{messages['net.ihe.gazelle.hpd.HPDSimulator']}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.simulators.Role']}</ui:define>
                                    <h:outputText value="#{managedBean.simulatedActor.name}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                    <div class="col-md-4">
                        <h:graphicImage library="img" name="diag/#{managedBean.simulatedActor.keyword}.png"/>
                    </div>
                    <div class="col-lg-4">
                        <gri:panel pid="sutConfig" rendered="#{managedBean.selectedSut != null}">
                            <f:facet name="header">#{messages['net.ihe.gazelle.hpd.SystemUnderTestSUT']})</f:facet>
                            <dl class="dl-horizontal">
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Name']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.name}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.simulator.System']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.systemName}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['gazelle.simulator.URL']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.url}"/>
                                </s:decorate>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.BaseDN']}</ui:define>
                                    <h:outputText value="#{managedBean.selectedSut.baseDN}"/>
                                </s:decorate>
                            </dl>
                        </gri:panel>
                    </div>
                </s:div>
                <div class="form-horizontal">
                    <s:decorate id="configSelectionDecorate" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.hpd.SystemUnderTest']}</ui:define>
                        <ui:param name="id" value="configSelectionBox"/>
                        <h:selectOneMenu id="configSelectionBox" value="#{managedBean.selectedSut}"
                                         styleClass="form-control gzl-select-text">
                            <s:selectItems value="#{managedBean.listAvailableSut()}" var="sut" label="#{sut.name}"
                                           noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                            <a4j:ajax event="change"
                                      execute="@this"
                                      render="sequenceDiagram, batchRequestDiv"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </div>
                <gri:panel pid="mainContentPanel">
                    <f:facet name="header">
                        <h:outputText value="Request content"/>
                        <h:commandLink actionListener="#{managedBean.setBatchRequestMap(null)}" render="mainContentPanel">
                            <span class="pull-right gzl-icon-times-circle" title="Clean up batch request"/>
                        </h:commandLink>
                    </f:facet>
                    <s:div styleClass="row" id="batchRequestDiv">
                        <div class="col-lg-2 scrollspy">
                            <nav class="gzl-sidebar" id="nav-sidebar">
                                <h3>#{messages['net.ihe.gazelle.hpd.BatchRequest']}</h3>
                                <ul class="nav" id="nav">
                                    <a4j:repeat value="#{managedBean.batchRequestMap}" var="req" id="requestList">
                                        <li>
                                            <a href="#req#{req.index}">
                                                <h:outputText value="#{req.index} - #{req.requestType.label}"
                                                              id="reqId"/>
                                            </a>
                                        </li>
                                    </a4j:repeat>
                                    <hr/>
                                    <div class="row">
                                        <div class="col-md-10">
                                            <h:selectOneMenu value="#{managedBean.selectedMessageType}"
                                                             styleClass="form-control">
                                                <f:selectItems value="#{managedBean.getAvailableRequestTypes()}"/>
                                            </h:selectOneMenu>
                                        </div>
                                        <div class="col-md-2">
                                            <a4j:commandLink actionListener="#{managedBean.addRequestToBatch()}"
                                                             render="batchRequestDiv">
                                                <s:span styleClass="gzl-icon-plus"
                                                        title="#{messages['net.ihe.gazelle.hpd.AppendANewRequest']}"/>
                                            </a4j:commandLink>
                                        </div>
                                    </div>
                                    <hr/>
                                    <div>
                                        <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.SendRequest']}"
                                                           rendered="#{managedBean.selectedSut != null and not empty managedBean.batchRequestMap}"
                                                           actionListener="#{managedBean.sendMessage()}"
                                                           render="globalDiv" styleClass="gzl-btn-blue"/>
                                    </div>
                                </ul>
                                <!--@formatter:off-->
                                <script>
                                    $(document).ready(function () {
                                        var sidebarTop = $('#nav-sidebar').offset().top;
                                        $(window).bind('scroll', function () {
                                            var navHeight = sidebarTop;
                                            if ($(window).scrollTop() > navHeight) {
                                                $('nav#nav-sidebar').addClass(' gzl-affix-right');
                                            }
                                            else {
                                                $('nav#nav-sidebar').removeClass(' gzl-affix-right');
                                            }
                                        });
                                    });
                                </script>
                                <!--@formatter:on-->
                            </nav>
                        </div>
                        <div class="col-lg-10">
                            <a4j:repeat value="#{managedBean.batchRequestMap}" var="currentReq">
                                <div id="req#{currentReq.index}">
                                    <gri:panel pid="requestConfPanel">
                                        <f:facet name="header">
                                            <h:outputText
                                                    value="#{currentReq.index} - #{currentReq.requestType.label}"/>
                                            <a4j:commandLink
                                                    actionListener="#{managedBean.removeRequestFromBatch(currentReq)}"
                                                    render="batchRequestDiv">
                                                <s:span styleClass="pull-right gzl-icon-trash-o"
                                                        title="#{messages['net.ihe.gazelle.hpd.RemoveRequestFromBatch']}"/>
                                            </a4j:commandLink>
                                        </f:facet>
                                        <ui:insert name="subviewsForRequests"/>
                                    </gri:panel>
                                </div>
                            </a4j:repeat>
                            <gri:panel pid="reportPanel" rendered="#{not empty managedBean.messages}">
                                <f:facet name="header">#{messages['net.ihe.gazelle.hpd.TestReport']}</f:facet>
                                <rich:dataTable value="#{managedBean.messages}" var="ti" rows="20"
                                                id="tableTransactionsSend"
                                                render="ds">
                                    <ui:include src="/messages/logger_columns.xhtml">
                                        <ui:param name="managedBean" value="#{hpdMessageBrowser}"/>
                                    </ui:include>
                                    <g:column>
                                        <f:facet name="header">Action</f:facet>
                                        <h:outputLink value="#{hpdMessageBrowser.permanentLink(ti)}" target="_blank;">
                                            <s:span styleClass="gzl-icon-search "/>
                                        </h:outputLink>
                                        <a4j:commandLink actionListener="#{hpdMessageBrowser.validate(ti)}"
                                                         oncomplete="jq162('#validationSummaryPanel').modal('show')"
                                                         render="validationSummaryPanelContent">
                                            <s:span styleClass="fa fa-play gzl-text-blue"/>
                                        </a4j:commandLink>
                                    </g:column>
                                </rich:dataTable>
                                <ui:include src="/messages/validationSummaryPanel.xhtml">
                                    <ui:param name="managedBean" value="#{hpdMessageBrowser}"/>
                                </ui:include>
                                <f:facet name="footer">
                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.PerformAnotherTest']}"
                                                       oncomplete="jq162('#performAnotherTestPanel').modal('show')"
                                                       styleClass="gzl-btn-blue"/>
                                    <ui:insert name="additionalButtonsOnReport"/>
                                </f:facet>
                            </gri:panel>
                            <ui:insert name="additionalPanels"/>
                        </div>
                    </s:div>
                </gri:panel>
            </gri:panel>
        </s:div>
        <!-- modalPanel displayed when user click on "Perform another test", ask the user if he/she wants to
                 reset the batchRequest content or not -->
        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="performAnotherTestPanel"/>
            <ui:define name="popup_title">#{messages['net.ihe.gazelle.hpd.PerformAnotherTest']}</ui:define>
            <h:outputText
                    value="#{messages['net.ihe.gazelle.hpd.YouAreAboutToPerformANewTestDoYouWantToStartFrom']}"/>
            <ui:define name="popup_footer">
                <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.Yes']}"
                                   actionListener="#{managedBean.setMessages(null)}"
                                   oncomplete="jq162('#performAnotherTestPanel').modal('hide')"
                                   render="globalDiv" styleClass="gzl-btn-blue"/>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.NoCleanUpTheBatchRequest']}"
                                   actionListener="#{managedBean.performAnotherTest()}"
                                   oncomplete="jq162('#performAnotherTestPanel').modal('hide')"
                                   render="globalDiv" styleClass="gzl-btn-red"/>
            </ui:define>
        </ui:decorate>
    </h:form>
</ui:composition>
